import json
import os

from parsivar import Normalizer, Tokenizer


def debugger(string):
    string = string.replace("\'", "\"")
    string = string.replace("\"\"\"", "\"\"")
    string = string.replace("\\", " ")
    return string


def token_maker(filename):
    filepath = os.path.join("./docs", filename)
    file = open(filepath, "r")
    obj = json.load(file)
    obj_cnt = ''
    lst = list()
    for ch in obj["content"]:
        lst.append(ch)
        obj_cnt = ''.join(lst)
    normalizer = Normalizer()
    pars_tokenizer = Tokenizer()
    normal_txt = normalizer.normalize(obj_cnt)
    tokens = pars_tokenizer.tokenize_words(normal_txt)
    output = dict()
    index = 0

    for word in tokens:
        if word not in output.keys():
            output[str(word)] = [index]
        else:
            indexes = output[word]
            indexes.append(index)
        index = index + 1

    filename = str(filename)
    tk_fl = open(f"document tokens/{filename}", "w", encoding="utf-8")
    str_out = str(output)
    str_out = debugger(str_out)
    tk_fl.write(str_out)


def get_file_test(files):
    counter = 0
    for f in files:
        token_maker(str(f))
        print(f"{int((counter / 23) * 100)}% is tokenized!")
        counter = counter + 1


def get_file(files):
    counter = 0
    for f in files:
        token_maker(str(f))
        print(f"{int((counter / 12201) * 100)}% is tokenized!")
        counter = counter + 1
